package pro.skywalking.utils;

import cn.hutool.core.util.StrUtil;
import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class StringTool {

   private static final Logger log = LoggerFactory.getLogger(StringTool.class);
   private static final Pattern PATTERN = Pattern.compile("_(\\w)");
   private static final Pattern PATTERN_A_Z = Pattern.compile("[A-Z]");


   public static StringBuffer camel(StringBuffer str) {
      Matcher matcher = PATTERN.matcher(str);
      StringBuffer sb = new StringBuffer(str);
      if(matcher.find()) {
         sb = new StringBuffer();
         matcher.appendReplacement(sb, matcher.group(1).toUpperCase());
         matcher.appendTail(sb);
         return camel(sb);
      } else {
         return sb;
      }
   }

   public static StringBuffer underline(StringBuffer str) {
      Matcher matcher = PATTERN_A_Z.matcher(str);
      StringBuffer sb = new StringBuffer(str);
      if(matcher.find()) {
         sb = new StringBuffer();
         matcher.appendReplacement(sb, "_" + matcher.group(0).toLowerCase());
         matcher.appendTail(sb);
         return underline(sb);
      } else {
         return sb;
      }
   }

   public static void main(String[] args) {
      String basePath = "/Users/singer/Downloads/第2节 Bolt数据库";
      String replaceName = "【海量资源尽在 】";
      File dir = new File(basePath);
      ArrayList allFileList = new ArrayList();
      if(!dir.exists()) {
         System.out.println("目录不存在");
      } else {
         getAllFile(dir, allFileList);

         String absolutePath;
         for(Iterator var5 = allFileList.iterator(); var5.hasNext(); log.info("重命名完成:{}", absolutePath)) {
            File file = (File)var5.next();
            absolutePath = file.getAbsolutePath();
            String name = file.getName();
            log.info("重命名前:{}", name);
            String newName = StrUtil.replace(absolutePath, replaceName, "", Boolean.TRUE.booleanValue());

            try {
               File e = new File(newName);
               if(!e.exists()) {
                  file.renameTo(e);
                  log.info("重命名后:{}", e.getName());
                  Thread.sleep(2L);
               }
            } catch (InterruptedException var11) {
               throw new RuntimeException(var11);
            }
         }

         System.out.println("该文件夹下共有" + allFileList.size() + "个文件");
      }
   }

   public static void getAllFile(File fileInput, List allFileList) {
      File[] fileList = fileInput.listFiles();

      assert fileList != null;

      File[] var3 = fileList;
      int var4 = fileList.length;

      for(int var5 = 0; var5 < var4; ++var5) {
         File file = var3[var5];
         if(file.isDirectory()) {
            getAllFile(file, allFileList);
         } else {
            allFileList.add(file);
         }
      }

   }

}
